package main

import (
	log "git.randomchars.net/FreeNitori/Log"
	multiplexer "git.randomchars.net/FreeNitori/Multiplexer"
	"github.com/bwmarrin/discordgo"
)

var allowedMessages map[string]bool

func init() {
	m.MessageReactionAdd = append(m.MessageReactionAdd, handleReaction)
	m.MessageCreate = append(m.MessageCreate, handleMessages)
}

func handleReaction(context *multiplexer.Context) {
	reactionAdd, ok := context.Event.(*discordgo.MessageReactionAdd)
	if !ok {
		return
	}

	if reactionAdd.GuildID == "" {
		return
	}
	if reactionAdd.UserID == session.State.User.ID {
		return
	}
	if !allowedMessages[reactionAdd.MessageID] {
		return
	}

	switch reactionAdd.Emoji.Name {
	case "1️⃣":
		setupTicket(config.GuildID, reactionAdd.UserID, 0, context.User)
	case "2️⃣":
		setupTicket(config.GuildID, reactionAdd.UserID, 1, context.User)
	case "3️⃣":
		setupTicket(config.GuildID, reactionAdd.UserID, 2, context.User)
	case "4️⃣":
		setupTicket(config.GuildID, reactionAdd.UserID, 3, context.User)
	default:
		return
	}
}

func handleMessages(context *multiplexer.Context) {
	if context.User.ID == session.State.User.ID {
		return
	}
	instance, ok := ticketInstancesChannel[context.Channel.ID]
	client := false
	if !ok {
		instance, ok = ticketInstancesUser[context.User.ID]
		if !ok {
			return
		}
		client = true
	}
	switch client {
	case true:
		sendMessage(instance.ChannelID, context.Message.Content)
	case false:
		if context.Message.Content == context.Prefix() + "close" {
			return
		}
		sendMessage(instance.UserChannelID, context.Message.Content)
	}
}

func sendMessage(channelID, message string) bool {
	if _, err := session.ChannelMessageSend(channelID, message); err != nil {
		log.Warnf("Error sending message to channel %s, %s", channelID, err)
		return false
	} else {
		return true
	}
}
